/*
 * Copyright (C) 2016  (See AUTHORS)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package owl.factories.jdd;

import static org.junit.Assert.assertEquals;

import com.google.common.collect.ImmutableSet;
import java.util.Set;
import org.junit.Before;
import org.junit.Test;

public class BddValuationSetFactoryTest {
  private Set<String> alphabet;
  private ValuationFactory factory;

  @Before
  public void setUp() {
    alphabet = ImmutableSet.of("a", "b");
    factory = new ValuationFactory(2);
  }

  @Test
  public void testCreateEmptyValuationSet() {
    assertEquals(0, factory.createEmptyValuationSet().size());
  }

  @Test
  public void testGetAlphabet() {
    assertEquals(alphabet.size(), factory.getSize());
  }
}
